<?php
/**
 * Controller for administrative functionality.
 * 
 * @version 0.8.0
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage controllers
 * @uses Authmodel PartsModel string
 */
class Admin extends SM_Controller {		
	function Admin() {
		parent::SM_Controller();
		$this->load->model(Array('AuthModel', 'PartsModel'));			
		$this->load->helper('string');	
	}
	
	/**
	 * Present administrative dashboard.
	 */
	function index() {
		if($this->AuthModel->getCurrentUserRole() == "admin") {
			$this->data('partsArray', $this->PartsModel->getPartsForApproval());
			$this->script(Array('admin.js'));
			$this->style(Array('admin.css'));					
			$this->display("Administrative Dashboard", "admin_view");
		}
		else { redirect(''); }			
	}
	
	function processRepoFeed() {
		$this->load->library('simplepie');
		$this->load->helper('text');
		$feed = "https://sourcemap.codebasehq.com/sourcemap/activity.rss?u=hock&ft=f6f57af7dbb7acfbff733df951a36e0b6cf1820a";
		$repo = new SimplePie();
		$repo->enable_cache(false);

		$repo->set_feed_url($feed);
		$repo->init();
		$repo->handle_content_type();

		$output = "";
		$items = $repo->get_items(0,1);
		foreach ($items as $item) {
			$output .= "<li><strong><a href='" . $item->get_permalink() . "'>" . $item->get_title() . "</a></strong><p>" .word_limiter(strip_tags($item->get_description()),20) . "</p></li>";

		}
		echo $output;
	}
} // End Admin