<?php
/**
 * Controller for maps on the site.
 *
 * @version 0.8
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage controllers
 */
class Map extends SM_Controller{	
	public function Map(){
		parent::SM_Controller();
		$this->load->model(Array('AuthModel','ObjectsModel'));
		$this->load->helper('googlemaps');
	}
		
	/**
	 * Embedded map display.
	 * @param $id the object id to visualize.
	 * @param $code boolean, display the embed code for this sourcemap or not.
	 */
	function embed($slug=null, $code=null){
		if($code) { 
			$this->data('oid', $slug);
			$base = "embeds/embedmap_code_view.php"; 
		}
		else {
			$object = $this->ObjectsModel->getObject($slug);			
			$this->data('object', $object);	
			$this->style(Array('mapembed.css'));		
			if($this->config->item('tileprovider') == "cloudmade") {
				$this->script(Array("http://www.google.com/jsapi?autoload=%7B%22modules%22%3A%5B%7B%22name%22%3A%22maps%22%2C%22version%22%3A%222%22%7D%2C%7B%22name%22%3A%22earth%22%2C%22version%22%3A%221%22%7D%5D%7D&key=".getGoogleMapsKey(base_url()), base_url()."assets/scripts/OpenLayers-2.8/OpenLayers.js", base_url()."assets/scripts/OpenLayers-2.8/cloudmade.js"), true);
			} else { 
				$this->script(Array("http://www.google.com/jsapi?autoload=%7B%22modules%22%3A%5B%7B%22name%22%3A%22maps%22%2C%22version%22%3A%222%22%7D%2C%7B%22name%22%3A%22earth%22%2C%22version%22%3A%221%22%7D%5D%7D&key=".getGoogleMapsKey(base_url()), base_url()."assets/scripts/OpenLayers-2.8/OpenLayers.js"), true);		
			}
			$this->script(Array('object.js', 'openlayers_map.js'));
			$this->scriptvar(Array( $this->ObjectsModel->generateJSONObject($object),
									"Sourcemap.tileprovider = '".$this->config->item('tileprovider')."';", 		
							   		"Sourcemap.geocodeprovider = '".$this->config->item('geocodeprovider')."';"));
		
			$base = "embeds/embedmap_view.php";
		}
		
		$this->display("Embed", $base);
	}
	
	/**
	 * Globe map display.
	 * @param $id the object id to visualize.
	 */
	function globe($slug=null){
		$object = $this->ObjectsModel->getObject($slug);
		$coords = explode("|", $object->latlon);
		
		$this->data('object', $object);
				$this->script(Array("http://www.google.com/jsapi?autoload=%7B%22modules%22%3A%5B%7B%22name%22%3A%22maps%22%2C%22version%22%3A%222%22%7D%2C%7B%22name%22%3A%22earth%22%2C%22version%22%3A%221%22%7D%5D%7D&key=".getGoogleMapsKey(base_url())), true);
		$this->script(Array('object.js','globe.js'));	
		$this->scriptvar(Array(
			$this->ObjectsModel->generateJSONObject($object),
			'var kmlurl = "'.base_url().'api/kml/'.$object->slug.'";',
			'var olat = Number('.$coords[0].');',
			'var olon = Number('.$coords[1].');'
		));
		
		$this->display("Globe of " . $object->name, "map/globemap_view.php");
	}
	
	/**
	 * Fullscreen map display.
	 * @param $id the object id to visualize.
	 */
	function fullscreen($slug=null){
		$object = $this->ObjectsModel->getObject($slug);
		
		$this->data('object', $object);
		if($this->config->item('tileprovider') == "cloudmade") {
			$this->script(Array("http://www.google.com/jsapi?autoload=%7B%22modules%22%3A%5B%7B%22name%22%3A%22maps%22%2C%22version%22%3A%222%22%7D%2C%7B%22name%22%3A%22earth%22%2C%22version%22%3A%221%22%7D%5D%7D&key=".getGoogleMapsKey(base_url()), base_url()."assets/scripts/OpenLayers-2.8/OpenLayers.js", base_url()."assets/scripts/OpenLayers-2.8/cloudmade.js"), true);
		} else { 
			$this->script(Array("http://www.google.com/jsapi?autoload=%7B%22modules%22%3A%5B%7B%22name%22%3A%22maps%22%2C%22version%22%3A%222%22%7D%2C%7B%22name%22%3A%22earth%22%2C%22version%22%3A%221%22%7D%5D%7D&key=".getGoogleMapsKey(base_url()), base_url()."assets/scripts/OpenLayers-2.8/OpenLayers.js"), true);		
		}
		$this->script(Array('object.js','openlayers_map.js'));	
		$this->scriptvar(Array($this->ObjectsModel->generateJSONObject($object), 
							   "Sourcemap.tileprovider = '".$this->config->item('tileprovider')."';", 		
							   "Sourcemap.geocodeprovider = '".$this->config->item('geocodeprovider')."';"));

		
		$this->display("Fullscreen Map of " . $object->name, "map/fullmap_view.php");
	}
	
	/**
	 * Print map display.
	 * @param $id the object id to visualize.
	 */
	function printer($slug=null){
		$object = $this->ObjectsModel->getObject($slug);		
		$this->data('object', $object);				
		$this->style(Array('print-map.css'));
		if($this->config->item('tileprovider') == "cloudmade") {
			$this->script(Array("http://www.google.com/jsapi?autoload=%7B%22modules%22%3A%5B%7B%22name%22%3A%22maps%22%2C%22version%22%3A%222%22%7D%2C%7B%22name%22%3A%22earth%22%2C%22version%22%3A%221%22%7D%5D%7D&key=".getGoogleMapsKey(base_url()), base_url()."assets/scripts/OpenLayers-2.8/OpenLayers.js", base_url()."assets/scripts/OpenLayers-2.8/cloudmade.js"), true);
		} else { 
			$this->script(Array("http://www.google.com/jsapi?autoload=%7B%22modules%22%3A%5B%7B%22name%22%3A%22maps%22%2C%22version%22%3A%222%22%7D%2C%7B%22name%22%3A%22earth%22%2C%22version%22%3A%221%22%7D%5D%7D&key=".getGoogleMapsKey(base_url()), base_url()."assets/scripts/OpenLayers-2.8/OpenLayers.js"), true);		
		}
		$this->script(Array('object.js','openlayers_map.js'));	
		$this->scriptvar(Array($this->ObjectsModel->generateJSONObject($object), 			
							   "Sourcemap.tileprovider = '".$this->config->item('tileprovider')."';", 		
				   			   "Sourcemap.geocodeprovider = '".$this->config->item('geocodeprovider')."';"));			
		
		$this->display("Printable Map of " . $object->name, "map/printmap_view.php");			
	}
}