
if ( typeof(Sourcemap) == 'undefined' ) {Sourcemap = {};}

Sourcemap.Catalogue = {
  init: function() {	
	this.ajaxopen = true;
	this.sorttype = "name";
	this.sortorder = "";
	this.pagenum = "";
	this.filterterm = "";
	
	this.createPagination = function() {
		var total = Number($("#cataloguetotal").text());
		var pages = Math.ceil(total / 30);
		var pagination = '<div class="pagination">';
		var currentpage = (this.pagenum == "") ? 0 : this.pagenum;
		
		if(pages > 1) {		
			var selected = (this.pagenum == 0) ? "selected" : "";
			pagination += '<span id="0" class="paginate '+selected+'">First</span> &bull; '; 
		
			for(i=currentpage/30-3; i <= currentpage/30; i++) {				
				if(!(i < 0)) {
					var selected = (this.pagenum == i*30) ? "selected" : "";
					label = i+1;
					pagination += '<span id="'+i*30+'" class="paginate '+selected+'">'+label+'</span> &bull; '; 
				}
			}
			for(i=currentpage/30+1; i <= currentpage/30 + 3; i++) {				
				if(!(i >= pages)) {
					var selected = (this.pagenum == i*30) ? "selected" : "";
					label = i+1;
					pagination += '<span id="'+i*30+'" class="paginate '+selected+'">'+label+'</span> &bull; '; 
				}
			}
			var selected = (this.pagenum == pages*30) ? "selected" : "";
			pagination += '<span id="'+pages*30+'" class="paginate '+selected+'">Last</span>'; 
		}
		
		pagination += '</div>';
		$(".pagination").replaceWith(pagination);
		$(".paginate").click(function() {
			Sourcemap.Catalogue.page($(this).attr("id"));
		});
	};
	this.page = function(page) {
		if(page == 0) {
			Sourcemap.Catalogue.pagenum = "";
		}
		else {
			Sourcemap.Catalogue.pagenum = page;
		}
		$.post(Sourcemap.siteurl+"catalogue/"+this.sorttype+this.sortorder+"/"+this.pagenum, {type: Sourcemap.Template.type, filter: $("#partchooserbox #filter").val(), typefilter: Sourcemap.Template.typefilter }, Sourcemap.Catalogue.create);		
		
	};
    this.create = function(catalogue) {
		Sourcemap.Catalogue.ajaxopen = true;	
		if(Sourcemap.Catalogue.filterterm != $("#partchooserbox #filter").val()) {
			Sourcemap.Catalogue.filter();
		} else {
			$("#catalogueshell").replaceWith(catalogue);
			$(".cataloguebutton, .cataloguename").click(function() {
				if($(this).hasClass("cataloguebutton")) {
					var catalogueitem = $(this).prev(".catalogueitem");
				}
				else {
					var catalogueitem = $(this).parents(".catalogueitem");					
				}
				var link = catalogueitem.find(".catalogue-slug").text();
				var type = catalogueitem.find(".cataloguecategory").text();

				if(type == "Object") {
					link = type.toLowerCase() + "/" + link;
				} 
				else {
					link = "parts/"+link; 
				}

				var name = catalogueitem.find(".cataloguename").text();
				var emissions = catalogueitem.find(".catalogue-emissions-value").text();
				objectConfig.addPart(name, "", emissions, link);
			});
			$("#custompartbutton").click(function() {			
				objectConfig.addPart(Sourcemap.Template.partstubname, "", 0, "");
			});
			
			Sourcemap.Catalogue.createPagination();
		}
	};
	this.filter = function() {
		this.pagenum = "";
		if(this.ajaxopen) {
			this.ajaxopen = false;	
			this.filterterm = $("#partchooserbox #filter").val();			
			$.post(Sourcemap.siteurl+"catalogue/"+this.sorttype+this.sortorder+"/"+this.pagenum, {type: Sourcemap.Template.type, filter: $("#partchooserbox #filter").val(), typefilter: Sourcemap.Template.typefilter}, Sourcemap.Catalogue.create);		
		}
	};
	this.sort = function(clicked) {
		this.pagenum = "";
		$(".cataloguesort").removeClass("selected");
		$(this).addClass("selected");	
		if(this.sorttype == clicked) {
			if(this.sortorder == "") {
				this.sortorder = "desc";
			} 
			else { 
				this.sortorder = "";
			}
		}
		else {
			this.sorttype = clicked;
			this.sortorder = "";
		}
		$.post(Sourcemap.siteurl+"catalogue/"+this.sorttype + this.sortorder+"/"+this.pagenum, {type: Sourcemap.Template.type, filter: $("#partchooserbox #filter").val(), typefilter: Sourcemap.Template.typefilter}, Sourcemap.Catalogue.create);				
	};
	$.post(Sourcemap.siteurl+"catalogue/"+ this.sorttype + this.sortorder, {type: Sourcemap.Template.type, typefilter: Sourcemap.Template.typefilter}, Sourcemap.Catalogue.create);	
	
	$("#partchooserbox #filter").keydown(function() { 
		Sourcemap.Catalogue.filter();
	});
	$(".cataloguesort").click(function() {	
		Sourcemap.Catalogue.sort($(this).attr("id"));
	});
	
  }
};

$(document).ready(function() {	
	Sourcemap.Catalogue.init();
});