/**
 * Sourcemap.Dashboard: Handles basic dashboard (user profile) functionality.
 *
 * @version 0.8
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage js
 */

if ( typeof(Sourcemap) == 'undefined' ) {Sourcemap = {};}

Sourcemap.Dashboard = {
  init: function() {
	this.updateProfile = function() {
	    var profile = {
		  id: $("#userid").text(),
		  description: $("#userprofile textarea").val()
      	};
	    var saveData = "data=" + JSON.stringify(profile) + "";	
		Sourcemap.pageTracker._trackEvent("Social", "Profile", "Updated profile for "+$("#userid").text()+"");	
	    $.post(Sourcemap.siteurl+"users/updatedashboard", saveData, Sourcemap.Dashboard.profileConfirmation );
	};
	this.profileConfirmation = function() {
		Sourcemap.debug("profile updated");
	};
  	this.updatePassword = function() {
	    var password = {
		  old: $("#oldpass").val(),
		  change: $("#newpass").val()
      	};
	    var saveData = "data=" + JSON.stringify(password) + "";	
	    $.post(Sourcemap.baseurl+"auth/changepassword", saveData, Sourcemap.Dashboard.passwordConfirmation );
	};
	this.passwordConfirmation = function(data) {
		if(data == "true") {			
			Sourcemap.debug("password changed");
			$("#oldpass").val(""),
		    $("#newpass").val("");
		}
	};
	this.switchTab = function(tabid) {
		$("ul#dashboard-tabs li").removeClass("selected");
		$(this).addClass("selected");
		
		$("#dashboard-tab-content div.tab-content").addClass("hidden");
		$("#dashboard-tab-content div#"+$(this).attr("id")+"-content").removeClass("hidden");

	};
	
	this.switchPasswordField = function(id) {
		$("#"+id).replaceWith('<input id="'+id+'" name="'+id+'" value="" type="password"/>');
		$("#"+id).focus();
	};
	$("ul#dashboard-tabs li").click(Sourcemap.Dashboard.switchTab);
	$("#profile-edit").click(Sourcemap.Dashboard.updateProfile);
	
	$("#oldpass, #newpass").focus(function() { if($(this).attr("type") != "password") { 
		Sourcemap.Dashboard.switchPasswordField($(this).attr("id"));
	}});

	$("#password-edit").click(Sourcemap.Dashboard.updatePassword);
  }
};

		

$(document).ready(function() {	
  Sourcemap.Dashboard.init();

});

