/**
 * Sourcemap.ObjectImporter: Handles importing Sourcemap Objects.
 *
 * @version 0.8
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage js
 */

if ( typeof(Sourcemap) == 'undefined' ) {Sourcemap = {};}

Sourcemap.ObjectImporter = {
  
  objectimport: function() {
	//submit multipart form to object/import_excel
	var theform = document.forms['import_form'];
	theform.submit();
  },
	
  confirm: function() {
		document.forms['confirm_import_form'].submit();
  },

  show_edit: function(oid) {
	  var editable = document.getElementById('editable_object_'+oid);
	  editable.setAttribute('class', 'single_edit');
	  editable.setAttribute('className', 'single_edit');//this is what IE expects
	  var readonly = document.getElementById('readonly_object_'+oid);
	  readonly.setAttribute('class', 'object_mini hidden');
	  readonly.setAttribute('className', 'object_mini hidden');//this is what IE expects
  },

  save_edit: function(oid) {
	  var editable = document.getElementById('editable_object_'+oid);
	  editable.setAttribute('class', 'single_edit hidden');
	  editable.setAttribute('className', 'single_edit hidden');//this is what IE expects
	  var readonly = document.getElementById('readonly_object_'+oid);
	  readonly.setAttribute('class', 'object_mini');
	  readonly.setAttribute('className', 'object_mini');//this is what IE expects
	  
	  var form = document.forms['single_edit_form_'+oid];
	  var object = new Object();
	  object.name = form.elements['name'].value;
	  object.description = form.elements['description'].value;
	  object.oid = form.elements['oid'].value;
	  object.origin = form.elements['object_origin'].value;
	  object.latlon = form.elements['latlon'].value;
	  object.parts = [];
	  var partNames = form.elements['part.name[]'];
	  for (i=0; i<partNames.length; i++){
		var part = new Object();
		part.imid = form['part.imid[]'][i].value;
		part.latlon = form['part.latlon[]'][i].value;
		part.name = partNames[i].value;
		part.origin = form['part.origin[]'][i].value;
		part.weight = form['part.weight[]'][i].value;
		part.rawemissions = form['part.rawemissions[]'][i].value;
		part.emissions = form['part.emissions[]'][i].value;
		part.shipping = form['part.shipping[]'][i].value;
		part.via = form['part.via[]'][i].value;
		part.description = form['part.description[]'][i].value;
		object.parts[i] = part;
	  }
	  var json_text  = JSON.stringify(object);
	  form.elements['sourcemap'].value = json_text;
	  var url = '../secure_save/'+oid;
	  Sourcemap.ObjectImporter.pending_oid = oid;
	  $.post(url,{sourcemap: json_text}, function(result) {
		  //todo: replace the contents of the read-only table to reflect what the user edited
		  replaceme = document.getElementById('readonly_object_'+Sourcemap.ObjectImporter.pending_oid);
		  replaceme.innerHTML=result;
	  });
	  

	  
	  var editable = document.getElementById('editable_object_'+oid);
	  editable.setAttribute('class', 'single_edit hidden');
	  editable.setAttribute('className', 'single_edit hidden');//this is what IE expects
	  var readonly = document.getElementById('readonly_object_'+oid);
	  readonly.setAttribute('class', 'object_mini');
	  readonly.setAttribute('className', 'object_mini');//this is what IE expects
	  
  }

};

