INSERT INTO processes (id, name, unit, description, type, emissions) VALUES 
(1, 'injection molding', 'kg', NULL, 'polymer', 0.5500),
(2, 'blow molding', 'kg', 'blow molding of bottles', 'polymer', 0.5100),
(3, 'rotation molding', 'kg', NULL, 'polymer', 0.7000),
(4, 'extrusion', 'kg', 'extrusion of solid profiles', 'polymer', 0.1600),
(5, 'thermoforming', 'kg', 'vacuum thermoforming', 'polymer', 0.3300),
(6, 'deep drawing', 'kg', 'drawing with heat', 'polymer', 0.0800),
(7, 'calendaring', 'kg', 'calendaring(rolling) film or sheet', 'polymer', 0.1600),
(8, 'film blow extrusion', 'kg', 'for films such as PE grocery sacks', 'polymer', 0.0200),
(9, 'iron casting', 'kg', NULL, 'metal', 0.9700),
(10, 'steel profile drawing', 'kg', 'drawing of pipes', 'metal', 0.1500),
(11, 'steel hot rolling', 'kg', 'hot rolling in foundry', 'metal', 0.1100),
(12, 'steel shearing', 'sqmt', 'from electrical consumption', 'metal', 0.0011),
(13, 'steel laser cutting', 'sqmt', 'from electrical consumption', 'metal', 0.0003),
(14, 'steel bandsawing', 'sqmt', 'from electrical consumption', 'metal', 0.0008),
(15, 'steel machining', 'kg', 'from electrical consumption', 'metal', 0.0360),
(16, 'steel turning', 'kg', 'from electrical consumption', 'metal', 0.0390),
(17, 'steel arc welding ', 'mt', NULL, 'metal', 0.0330),
(18, 'steel gas welding', 'mt', NULL, 'metal', 0.0440),
(19, 'steel MIG welding', 'mt', 'electrical MIG steel welding', 'metal', 0.8200),
(20, 's.steel rolling', 'kg', 'rolling of stainless steel sheet', 'metal', 0.2400),
(21, 'aluminum extrusion', 'kg', 'of profiles like window frames', 'metal', 280.0000),
(22, 'al.machining', 'kg', 'from electrical consumption', 'metal', 0.0630),
(23, 'al.bandsawing', 'sqmt', 'from electrical consumption', 'metal', 0.0005),
(24, 'aluminum shearing', 'sqmt', 'cuttin with shears', 'metal', 0.0980),
(25, 'aluminum forging', 'kg', 'from electrical consumption', 'metal', 0.1700),
(26, 'al. foam casting', 'kg', 'lost EPS foam casting', 'metal', 5.2000),
(27, 'al. mold casting', 'kg', 'semi-permanent mold casting', 'metal', 1.3000),
(28, 'aluminum rolling', 'kg', 'rolling of aluminum sheet', 'metal', 0.2500),
(29, 'aluminum turning', 'kg', NULL, 'metal', 0.0670),
(30, 'al. seam welding ', 'mt', 'continuous 0.06 inch x 12 inch', 'metal', 4.6000),
(31, 'al. MIG welding ', 'mt', 'MIG arc welding with helium', 'metal', 0.0560),
(32, 'al. spot welding', 'spot', '0.2 inch x 0.2 inch weld', 'metal', 0.0940),
(33, 'al. anodizing ', 'sqmt', NULL, 'metal', 0.3400),
(34, 'al. powder coating', 'sqmt', 'powder coating on aluminum', 'metal', 0.3200),
(35, 'st.powder coating', 'sqmt', 'powder coating on steel', 'metal', 0.3900),
(36, 'copper drawing', 'kg', 'copper wire drawing', 'metal', 0.8700),
(37, 'brass casting', 'kg', NULL, 'metal', 0.0270),
(38, 'bronze casting', 'kg', NULL, 'metal', 0.0280),
(39, 'steel enameling', 'sqmt', '0.12 lb procelain enamel /sqft', 'metal', 0.7200),
(40, 'steel phosphating', 'sqmt', 'from electrical consumption', 'metal', 0.1100),
(41, 'chrome plating', 'sqmt', 'electrolytic 10 mm, two sided', 'metal', 0.2600),
(42, 'nickel plating', 'sqmt', 'electrolytic 6mm, two sided', 'metal', 0.3500),
(43, 'zinc galvanizing', 'sqmt', 'electrolytic 3mm, two sided', 'metal', 0.2300),
(44, 'zinc coating', 'sqmt', 'dipping in hot zinc bath', 'metal', 0.4700);

select setval('processes_id_seq',45);
