DROP TABLE IF EXISTS objects_complex;
CREATE TABLE objects_complex (
  "oid" serial,
  type character varying(128) NOT NULL DEFAULT 'object',
  flag character varying(128) DEFAULT NULL,
  creator integer DEFAULT NULL,
  name character varying(128) DEFAULT NULL,
  upc character varying(128) NOT NULL DEFAULT '000000',
  imagelink character varying(128) NOT NULL DEFAULT '',
  description text,
  slug character varying(128) NOT NULL DEFAULT '',
  category character varying(128) DEFAULT NULL,
  origin character varying(128) DEFAULT NULL,
  latlon character varying(128) DEFAULT '0|0',
  destination character varying(128) DEFAULT NULL,
  weight float DEFAULT '0',
  emissions float DEFAULT '0',
  embodied float NOT NULL DEFAULT '0',
  transport float NOT NULL DEFAULT '0',
  process float DEFAULT '0',	   
  endoflife float DEFAULT '0',
  shipping float DEFAULT NULL,
  via character varying(128) DEFAULT NULL,
  lifetime integer DEFAULT NULL,
  usagetype character varying(128) DEFAULT NULL,
  usageenergy float DEFAULT NULL,
  usageemissions float DEFAULT NULL,
  timecreated timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  timemodified timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  visibility character varying(128) NOT NULL DEFAULT 'public',
  showfootprint character varying(128) NOT NULL DEFAULT 'on',
  showembodied character varying(128) NOT NULL DEFAULT 'on',
  showtransport character varying(128) NOT NULL DEFAULT 'on',
  showprocess character varying(128) NOT NULL DEFAULT 'on',
  showendoflife character varying(128) NOT NULL DEFAULT 'on',
  showlastleg character varying(128) NOT NULL DEFAULT 'on',
  showuse character varying(128) NOT NULL DEFAULT 'on',
  showstats character varying(128) NOT NULL DEFAULT 'on',
  CONSTRAINT pk_objects_complex_oid PRIMARY KEY (oid),
  CONSTRAINT uniq_objects_complex_slug UNIQUE (slug) 
);

GRANT all privileges on objects_complex to sourcemap;
GRANT all privileges on objects_complex_oid_seq to sourcemap;