DROP TABLE IF EXISTS transport;
CREATE TABLE transport (
  id serial,
  uid integer DEFAULT NULL,
  class character varying(128) DEFAULT NULL,
  name character varying(128) DEFAULT NULL,
  unit character varying(128) DEFAULT NULL,
  description text,
  co2_eq decimal(11,4) DEFAULT NULL,
  modified timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  CONSTRAINT pk_transport_id PRIMARY KEY (id)
);

CREATE TRIGGER transport_mod
  BEFORE UPDATE
  ON transport
  FOR EACH ROW EXECUTE PROCEDURE update_modified_column();

GRANT all privileges on transport to sourcemap;
GRANT all privileges on transport_id_seq to sourcemap;