DROP TABLE IF EXISTS users;
CREATE TABLE users (
  id serial,
  name character varying(128) DEFAULT NULL,
  role character varying(128) DEFAULT NULL,
  email character varying(255) DEFAULT NULL,
  pass character varying(60) DEFAULT NULL,
  description text,
  contactable boolean DEFAULT TRUE,
  created timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  modified timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  last_login timestamp DEFAULT NULL,
  CONSTRAINT pk_users_id PRIMARY KEY (id),
  CONSTRAINT uniq_user_name UNIQUE (name)
);

CREATE TRIGGER users_mod
  BEFORE UPDATE
  ON users
  FOR EACH ROW EXECUTE PROCEDURE update_modified_column();
  
GRANT all privileges on users to sourcemap;
GRANT all privileges on users_id_seq to sourcemap;