-- Table: materialscatalogue_impactsubmissions

-- DROP TABLE materialscatalogue_impactsubmissions;

CREATE TABLE materialscatalogue_impactsubmissions
(
  submission_id serial NOT NULL,
  material_id serial NOT NULL,
  reference_id serial NOT NULL,
  impact_category text NOT NULL,
  long_description text NOT NULL,
  short_description text NOT NULL,
  aspect_value double precision NOT NULL,
  aspect_unit text NOT NULL,
  impact_value double precision NOT NULL,
  impact_unit text NOT NULL,
  CONSTRAINT materialscatalogue_impactsubmissions_pkey PRIMARY KEY (submission_id),
  CONSTRAINT materialscatalogue_impactsubmissions_material_id_fkey FOREIGN KEY (material_id)
      REFERENCES materialscatalogue_materials (material_id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT materialscatalogue_impactsubmissions_reference_id_fkey FOREIGN KEY (reference_id)
      REFERENCES materialscatalogue_references (reference_id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE materialscatalogue_impactsubmissions OWNER TO sourcemap;
